/***************************************************************************
 *            netgetfile.c
 *
 *  Fri Oct 24 11:27:36 2003
 *  Copyright  2003  Phil Kett
 *  pkett@genesis-midi.com
 ****************************************************************************/

#include "../include/remsync.h"


int
netgetfile (char *src_file, char *dest_file, int port, char *servername,
	    int filemode)
{
	int client_socket;
	char command[BIG_BUF], message[BIG_BUF];
	char asize[BIG_BUF], acsum[BIG_BUF];
	char dummy1[BIG_BUF], dummy2[BIG_BUF], filename[BIG_BUF],
		buffer[BIG_BUF];
	int csum, size, rnd, local_csum, sizeread;
	FILE *client_file;
	int local_file, total_read;
	int block_len = 256;

	client_socket = init_client (port, servername);
	client_file = fdopen (client_socket, "r+");

	sprintf (command, "send:%s\r\n", src_file);
	send (client_socket, command, strlen (command), 0);

	fgets (message, BIG_BUF, client_file);
	strip_string (message);
	split_string (message, dummy1, dummy2);
	split_string (dummy2, asize, dummy1);
	split_string (dummy1, asize, acsum);
	size = atoi (asize);
	csum = atoi (acsum);

	sprintf (command, "OK\r\n");
	send (client_socket, command, strlen (command), 0);

	rnd = rand ();
	sprintf (filename, "%sremsync.%d",conf.dest, rnd);
	local_file =
		open (filename,
		      O_CREAT | O_TRUNC | O_WRONLY | O_BINARY, 0777);
	if (local_file == NULL) {
		return(1);
	}
	//printf ("Local File %s\nRemote File %s\nSize %d\n",filename, src_file, size);
	sizeread = 0;
	total_read = 0;
	if (size != 0)
	{
		bzero (buffer, BIG_BUF);
		while ((total_read < size))
		{
			sizeread = read (client_socket, buffer, block_len);
			total_read += sizeread;
			write (local_file, buffer, sizeread);
		}
	} else {
		//Handle the case of zero byte files
		// seems to cause problems with the handshaking
		sleep (1);
	}
	
	local_csum = cksum (filename);
	if (local_csum != csum)
	{
		printf ("csum Local = %d, Remote = %d\n", local_csum, csum);
		perror("Error!!! Checksums wrong!");
		return (1);
	}
	else
	{
		syslog(LOG_INFO, "Renaming file %s to %s\n", filename, dest_file);
		rename (filename, dest_file);
		chmod (dest_file, filemode);


	}
	//printf("Got local file, closing and quitting\n");
	close (local_file);
	client_quit (client_socket);
	fclose (client_file);
	close (client_socket);
	return (0);
}
